//small adjustment insert 5 lines
#include <graphics.h>
#include <iostream>
#include <windows.h>
#include "TVoutemul.h"
SerialCL Serial;

#define PROGMEM 
using namespace std;

//Adjustment comment 1 line
//#include <TVout.h>
 
TVout TV;
 
#define BALLS      10 // Number of balls to bounce.
#define BALLSIZE   4  // Size of balls.
#define PLAYERSIZE 6  // Size of player.
 
#define ANALOGXPIN 0  // Pin 0 is X on iTead joystick
#define ANALOGYPIN 1  // Pin 1 is Y on iTead joystick
 
#define PLAYERW    8  // Width of player.
#define PLAYERH    7  // Height of player.
#define PFRAMES    4  // Frames for the player.
#define PFRATE     5  // Count to 5, display next frame.
 
#define BORDERSIZE 2  // 1 pixel border around the screen
 
PROGMEM const unsigned char pacman[PFRAMES][PLAYERH+2] = {
  { // Closed
    PLAYERW,PLAYERH,  // width, height
    0x3c, // 60, // 0b00111100,
    0x7e, //126, // 0b01111110,
    0xff, //255, // 0b11111111,
    0xff, //255, // 0b11111111,
    0xff, //255, // 0b11111111,
    0x7e, //126, // 0b01111110,
    0x3c, // 60  // 0b00111100
  }
  ,
  { // Open Small
    PLAYERW,PLAYERH,  // width, height
    0x3c, //60,  //0b00111100,
    0x7e, //126, //0b01111110,
    0xFC,//,252, //0b11111100,
    0xf0, //240 ,//0b11110000,
    0xfc, //252 ,//0b11111100,
    0x7e, //126, //0b01111110,
    0x3c, //60   //0b00111100
  }
  ,
  { // Open Big
    PLAYERW,PLAYERH,  // width, height
    0x3c, //60,   //0b00111100,
    0x7e, //126, // 0b01111100,
    0xF8, //248, // 0b11111000,
    0xF0, //240, // 0b11110000,
    0xF8, //  248,//0b11111000,
    0x7e, // 126, //0b01111100,
    0x3c, //  60, //0b00111100
  }
  ,
  { // Open Small
    PLAYERW,PLAYERH,  // width, height
    0x3c, //60, //0b00111100,
    0x7e, //126,//0b01111110,
    0xFc, //252,//0b11111100,
    0xF0, //240,//0b11110000,
    0xfc, //252,//0b11111100,
    0x7e, //126,//0b01111110,
    0x3c, //60, //0b00111100
  }
};
 
void setup()
{
  uint8_t i;

  TV.begin(NTSC, 120, 96);
  Serial.begin(9600);
 
  TV.clear_screen();
 
  for (i=0; i<BORDERSIZE; i++)
  {
    //TV.draw_rect(i, i, TV.hres()-i*2-1, TV.vres()-i*2-1, WHITE);
  }
}
 
void loop()
{
  uint8_t  x[BALLS], y[BALLS];    // X and Y position of ball
  int8_t   xm[BALLS], ym[BALLS];  // X and Y movement of ball
  uint8_t  i;       // counter
 
  uint8_t  px, py;                // X and Y position of player
  uint8_t  playerFrame;           // Player frame to display
  uint8_t  playerRate;            // Frame speed counter
 
  // Initialize balls.
  for (i=0; i<BALLS; i++)
  {
    // Random position
    x[i] = random(BALLSIZE+BORDERSIZE, TV.hres()-BALLSIZE-BORDERSIZE-1);
    y[i] = random(BALLSIZE+BORDERSIZE, TV.vres()-BALLSIZE-BORDERSIZE-1);
 
    // Random direction
    xm[i] = random(2)*2 - 1;
    ym[i] = random(2)*2 - 1;

}
 
  // Initialize player.
  px = TV.hres()/2;
  py = TV.vres()/2;
 
  playerFrame = 0;
  playerRate = 0;
 
  // We will do our own control loop here.
  while(1)
  {
    // Wait for end of screen to be drawn.
    TV.delay_frame(1);
 
    for (i=0; i<BALLS; i++)
    {
      // Erase balls.
      TV.draw_circle(x[i], y[i], BALLSIZE, BLACK);
 
      x[i] = x[i] + xm[i];
      if (x[i]<=BALLSIZE+BORDERSIZE || x[i]>=TV.hres()-BALLSIZE-BORDERSIZE-1)
      {
        xm[i] = -xm[i];
        x[i] = x[i] + xm[i];
      }
      y[i] = y[i] + ym[i];
      if (y[i]<=BALLSIZE+BORDERSIZE || y[i]>=TV.vres()-BALLSIZE-BORDERSIZE-1)
      {
        ym[i] = -ym[i];
        y[i] = y[i] + ym[i];
      }
 
      TV.draw_circle(x[i], y[i], BALLSIZE, WHITE);
    }
 
    // Erase player
    TV.draw_rect(px, py, PLAYERW, PLAYERH, BLACK, BLACK);
 
    // Read joystick (0-1023) and convert to screen resolution.
    px = analogRead(ANALOGXPIN)/(1024/TV.hres());
    if (px<BORDERSIZE)
    {
      px = BORDERSIZE;
    }
    else if (px>=TV.hres()-PLAYERW-BORDERSIZE-1)
    {
      px = TV.hres()-PLAYERW-BORDERSIZE-1;
    }
 
    py = analogRead(ANALOGYPIN)/(1024/TV.vres());
    if (py<BORDERSIZE)
    {
      py = BORDERSIZE;
    }
    else if (py>=TV.vres()-PLAYERH-BORDERSIZE-1)
    {
      py = TV.vres()-PLAYERH-BORDERSIZE-1;
    }
 
    // Draw player.
    TV.bitmap(px, py, pacman[playerFrame]);
 
    playerRate++;
    if (playerRate>=PFRAMES)
    {
      playerRate = 0;
      playerFrame++;
      if (playerFrame>=PFRAMES)
      {
        playerFrame = 0;
      }
    }
  }
}

// adjustment insert main
int main()
{    
    TV.scale=5;

    setup();  
    loop();
}

